Doxygen
===============
Doxygen is the de facto standard tool for generating documentation from 
annotated C++ sources, but it also supports other popular programming 
languages such as C, Objective-C, C#, PHP, Java, Python, IDL 
(Corba, Microsoft, and UNO/OpenOffice flavors), Fortran, VHDL, Tcl, 
and to some extent D.

Doxygen can help you in three ways:

1. It can generate an on-line documentation browser (in HTML) and/or an 
   off-line reference manual (in LaTeX) from a set of documented source files. 
   There is also support for generating output in RTF (MS-Word), PostScript, 
   hyperlinked PDF, compressed HTML, DocBook and Unix man pages. 
   The documentation is extracted directly from the sources, which makes 
   it much easier to keep the documentation consistent with the source code.
2. You can configure doxygen to extract the code structure from undocumented 
   source files. This is very useful to quickly find your way in large 
   source distributions. Doxygen can also visualize the relations between 
   the various elements by means of include dependency graphs, inheritance 
   diagrams, and collaboration diagrams, which are all generated automatically.
3. You can also use doxygen for creating normal documentation (as I did for 
   the doxygen user manual and doxygen web-site).

Download
---------
The latest binaries and source of Doxygen can be downloaded from:
* http://www.doxygen.org/

Developers
---------
* Build Status: <a href="https://travis-ci.org/doxygen/doxygen"><img src="https://secure.travis-ci.org/doxygen/doxygen.png?branch=master"/></a>

* Install
  * Quick install see (./INSTALL) 
  * else http://www.doxygen.org/manual/install.html

Issues, bugs, requests, ideas
----------------------------------
Use the bug tracker to report bugs:
* current list:
    * [Bugzilla](https://bugzilla.gnome.org/buglist.cgi?product=doxygen&bug_status=UNCONFIRMED&bug_status=NEW&bug_status=ASSIGNED&bug_status=REOPENED)
* Submit a new bug or feature request 
    * [Enter bug](https://bugzilla.gnome.org/enter_bug.cgi?product=doxygen)

Comms
----------------------------------
### Mailing Lists ###

There are three mailing lists:

* doxygen-announce@lists.sourceforge.net     - Announcement of new releases only
* doxygen-users@lists.sourceforge.net        - for doxygen users
* doxygen-develop@lists.sourceforge.net      - for doxygen developers
* To subscribe follow the link to
    * http://sourceforge.net/projects/doxygen

Source Code
----------------------------------
In May 2013, Doxygen moved from 
subversion to git hosted at github
* https://github.com/doxygen/doxygen

Enjoy,

Dimitri van Heesch (dimitri at stack.nl)
